<template>
  <aside class="gpa-path-selector-panel">
    <gpa-path-inputs :name="inputs.name"
                     :stroke-width="inputs.strokeWidth"
                     :stroke-color="inputs.strokeColor"
                     :background-color="inputs.backgroundColor"
                     :stroke-style-preset="inputs.strokeStylePreset"
                     @change="updateInput" />

    <rui-actions bottom>
      <rui-button variant="recording" @click="emitStyleChange">{{ $t('generic.ok') }}</rui-button>
    </rui-actions>
  </aside>
</template>

<script>
import RuiActions from '@experiments-labs/rise_ui/src/components/Actions/Actions.vue'
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'

import { randomString } from '@experiments-labs/rise_ui/src/lib/String.js'
import GpaPathInputs from './_Inputs.vue'

export default {
  name: 'GpaPathSelector',
  emits: [
    'style-change',
    'update:modelValue',
  ],
  components: { RuiButton, RuiActions, GpaPathInputs },
  props: {
    pathStyle: { required: true, type: Object },
    modelValue: { required: false, type: String, default: null },
  },
  data () {
    return {
      showDescriptionOf: null,
      searchTerm: '',
      formId: randomString(),
      inputs: {
        name: this.$props.modelValue,
        strokeColor: '0,0,0,1',
        backgroundColor: '0,0,0,0.2',
        strokeWidth: 1,
        strokeStylePreset: 'default',
      },
    }
  },
  methods: {
    emitStyleChange () {
      this.$emit('style-change', {
        strokeColor: this.inputs.strokeColor,
        backgroundColor: this.inputs.backgroundColor,
        strokeWidth: this.inputs.strokeWidth,
        strokeStylePreset: this.inputs.strokeStylePreset,
      })
    },
    updateInput ({ key, value }) { this.inputs[key] = value },
  },
  watch: {
    pathStyle () {
      this.inputs.strokeColor = this.pathStyle.strokeColor
      this.inputs.strokeWidth = this.pathStyle.strokeWidth
      this.inputs.backgroundColor = this.pathStyle.backgroundColor
      this.inputs.strokeStylePreset = this.pathStyle.strokeStylePreset
    },
    modelValue (newValue, oldValue) { if (newValue !== oldValue) this.inputs.name = newValue },
  },
}
</script>

<style lang="scss" src="./_Selector.scss" />
